/*
 * util,h: prototypes for various utility functions
 * 
 * Copyright 2002 the Ithildin Project.
 * See the COPYING file for more information on licensing and use.
 * 
 * $Id$
 */

#ifndef UTIL_H
#define UTIL_H

/* map a file into memory in various ways */
char *mmap_file(char *);
char **mmap_file_to_array(char *);
char *sfgets(char *, int, FILE *);

bool is_absolute_path(const char *);
char *basename(const char *);
char *dirname(const char *);

/* subtract timeval 1 from timeval 2 */
struct timeval *subtract_timeval(struct timeval tv1, struct timeval tv2);
/* add timeval 1 and timeval 2 */
struct timeval *add_timeval(struct timeval tv1, struct timeval tv2);

/* take a file size and turn it into a string measure (e.g. 1024 = 1kb) */
char *canonize_size(uint64_t size);

#endif
/* vi:set ts=8 sts=4 sw=4 tw=76 et: */
