/*
 * superstring.c: General functions for the SuperString library
 * 
 * Copyright 2007 Chip Norkus.
 * See the COPYING file for more information on licensing and use.
 * 
 */

#include <superstring/superstring.h>
#include "superstring_private.h"

IDSTRING(rcsid, "$Id$");

/* initialize global data */
struct _superstring_global_data_ superstring_global_data = {
    malloc, realloc, free
};

int ss_errno = SS_ERROR_SUCCESS;

int ss_allocator_set(superstring_malloc_function malloc_func,
                     superstring_realloc_function realloc_func,
                     superstring_free_function free_func) {

    if (malloc_func == NULL || realloc_func == NULL ||
        free_func == NULL)
        ss_returnerror(SS_ERROR_INVALID_PARAMETER);

    superstring_global_data.malloc = malloc_func;
    superstring_global_data.realloc = realloc_func;
    superstring_global_data.free = free_func;

    ss_returnerror(SS_ERROR_SUCCESS);
}

/* vi:set ts=8 sts=4 sw=4 tw=76 et: */
